#!/bin/sh --
#
# Automatically generate animation and recorder rules from model XMLs.
#
# Name the gauges that are already smooth in JSBSim "gauge_nofilter",
# you do not have to rename the JSBSim property, only the animation
# property.
# Append "_noauto" to any type to make the script ignore it.
#
# TODO Rewrite in something with proper XML parsing?


INFILES=Models/Tu-144D-cockpit/*/*.xml
PRULEFILE=PRules/animations-autogen.xml
RECFILE=Systems/flightrecorder/Tu-144D-autogen.xml


PROPLIST=$(sed -e's/></>\
 </g' ${INFILES:?} |
 grep -e'<property>' -e'-prop>' -e'<use>' |
 sed -e's:</*property>::g' -e's:</*[A-Za-z]*-prop>::g' -e's:</*use>::g' -e's/  *//g' |
 sort |
 uniq
)

echo '<?xml version="1.0" encoding="UTF-8"?>
<PropertyList>
<!-- XXX Do not edit this file! Run bin/update-animation-filters.sh instead. -->' >${PRULEFILE}
cp -f ${PRULEFILE} ${RECFILE}

for prop in ${PROPLIST}; do
 case ${prop} in
  # JSBSim outputs should be animated via property rules performance, smoothing and recording.
  instrumentation/jsbsim*)
   jsbprop=$(echo ${prop} |sed -e's:^instrumentation/:/fdm/:' -e's:_nofilter/:/:g')
   prop=$(echo /${prop})
   case ${prop} in
    *_noauto/*)
     echo "Info: ignoring ${prop}." >&2
    ;;
    */light/*)
     echo "<filter><type>exponential</type><filter-time>0.05</filter-time><input>${jsbprop}</input><output>${prop}</output></filter>" >>${PRULEFILE}
     echo "<signal><property type=\"string\">${prop}</property><type>float</type></signal>" >>${RECFILE}
    ;;
    */gauge/*|*/flag/*|*/lightsrc/*)
     echo "<filter><type>exponential</type><filter-time>0.08</filter-time><input>${jsbprop}</input><output>${prop}</output></filter>" >>${PRULEFILE}
     echo "<signal><property type=\"string\">${prop}</property><type>float</type></signal>" >>${RECFILE}
    ;;
    */counter/*)
     echo "<filter><type>exponential</type><filter-time>0.008</filter-time><input>${jsbprop}</input><output>${prop}</output></filter>" >>${PRULEFILE}
     echo "<signal><property type=\"string\">${prop}</property><type>int</type><interpolation>discrete</interpolation></signal>" >>${RECFILE}
    ;;
    */lever/*|*/pot/*|*/gauge_nofilter/*|*/counter_nofilter/*)
     echo "<filter><type>gain</type><gain>1.0</gain><input>${jsbprop}</input><output>${prop}</output></filter>" >>${PRULEFILE}
     echo "<signal><property type=\"string\">${prop}</property><type>float</type></signal>" >>${RECFILE}
    ;;
    */switch/*|*/button/*|*/ELD/*)
     echo "<filter><type>gain</type><gain>1.0</gain><input>${jsbprop}</input><output>${prop}</output></filter>" >>${PRULEFILE}
     echo "<signal><property type=\"string\">${prop}</property><type>int</type><interpolation>discrete</interpolation></signal>" >>${RECFILE}
    ;;
    *)
     echo "Error: ${prop} does not match any filter/recorder type." >&2
     exit 1
    ;;
   esac
  ;;
  # The inputs can be animated directly from JSBSim tree, then they only need recorder.
  # FGBUG FIXME Recording switches does some mighty fuckup in JSBSim. Have to convert switches to use "instrumentation/" for the output and "fdm/" for the input.
  fdm/jsbsim*)
   prop=$(echo /${prop})
#   case ${prop} in
#    *_noauto/*)
#     echo "Info: ignoring ${prop}." >&2
#    ;;
#    */lever/*|*/pot/*)
#     echo "<signal><property type=\"string\">${prop}</property><type>float</type></signal>" >>${RECFILE}
#    ;;
#    # FIXME Rename input counters to something else to avoid confusion?
#    */switch/*|*/button/*|*/counter/*)
#     echo "<signal><property type=\"string\">${prop}</property><type>int</type><interpolation>discrete</interpolation></signal>" >>${RECFILE}
#    ;;
#    *)
#     echo "Error: ${prop} does not match any recorder type." >&2
#     exit 1
#    ;;
#   esac;
  ;;
  *)
   echo "Warning: ${prop} is outside of dedicated property trees." >&2
  ;;
 esac
done

echo '</PropertyList>' >>${PRULEFILE}
echo '</PropertyList>' >>${RECFILE}
